datablock AudioProfile(RainbowizerFireSound)
{
    filename = "./Rainbowizer_fire.wav";
    description = AudioClose3d;
    preload = true;
};

datablock AudioProfile(RainbowizerbulletHitSound)
{
   filename    = "./bullet_hit.wav";
   description = AudioClose3d;
   preload = true;
};

AddDamageType("Rainbowizer",'<bitmap:add-ons/Weapon_Rainbowizer/ci_Rainbowizer> %1','%2 <bitmap:add-ons/Weapon_Rainbowizer/ci_Rainbowizer> %1',0.2,1);

datablock ParticleData(RainbowizerParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/thinring";
	spinSpeed		= 50.0;
	spinRandomMin		= -600.0;
	spinRandomMax		= 600.0;
	colors[0]     = "0.4 0 0.5 1";
	colors[1]     = "1 0 0.0 1";
	colors[2]     = "1 0.8 0 1";
	colors[3]     = "0 1 0 1";
	sizes[0]      = 0.55;
	sizes[1]      = 0.45;
	sizes[2]      = 0.35;
	sizes[3]      = 0.25;
	times[0] = 0.0;
	times[1] = 0.30;
	times[2] = 0.60;
	times[3] = 1.0; 
	windCoefficient = 0.0;
	useInvAlpha = false;
};

datablock ParticleEmitterData(RainbowizerEmitter)
{
	ejectionPeriodMS = 1.5;
	periodVarianceMS = 0;
	ejectionVelocity = 4;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 89.999999;
	thetaMax         = 90;
	phiReferenceVel  = 36000;
	phiVariance      = 1;
	overrideAdvance = false;
	particles = "RainbowizerParticle";
	useEmitterColors = false;
	uiName = "";
};

datablock ParticleEmitterData(RainbowizerExplosionEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 6.5;
	velocityVariance = 0.5;
	ejectionOffset   = 0.0;
	thetaMin         = 0;
	thetaMax         = 180;
	phiReferenceVel  = 200;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "RainbowizerParticle";
	useEmitterColors = true;
	uiName = "";
};

datablock ExplosionData(RainbowizerExplosion)
{
	soundProfile = RainbowizerbulletHitSound;
	lifeTimeMS = 200;
	particleEmitter = RainbowizerExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	emitter[0] = RainbowizerEmitter;
	faceViewer     = true;
	explosionScale = "1 1 1";
	lightStartRadius = 5;
	lightEndRadius = 10;
	lightStartColor = "1 0.8 0.2 1";
	lightEndColor = "0.4 0.0 0.0 1";
	damageRadius = 2.8;
	radiusDamage = 8;
	impulseRadius = 3;
	impulseForce = 900;
};

datablock ProjectileData(RainbowizerProjectile)
{
	projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
	directDamage        = 10;
	directDamageType = $DamageType::Rainbowizer;
	radiusDamageType = $DamageType::Rainbowizer;
	impactImpulse	   = 10;
	verticalImpulse	   = 10;
	explosion           = RainbowizerExplosion;
	particleEmitter	   = RainbowizerEmitter;
	muzzleVelocity      = 70;
	velInheritFactor    = 1.0;
	armingDelay         = 0;
	lifetime            = 1800;
	fadeDelay           = 1500;
	bounceElasticity    = 0.5;
	bounceFriction      = 0.20;
	isBallistic         = false;
	gravityMod = 0.0;
	explodeOnDeath = true;
	hasLight    = true;
	lightRadius = 5.0;
	lightColor  = "1 0.8 0.2";
	uiName = "Rainbowizer Bullet";
};

datablock ItemData(RainbowizerItem)
{
    category = "Weapon";
    className = "Weapon";
    shapeFile = "./guitar gun.dts";
    rotate = false;
    mass = 1;
    density = 0.2;
    elasticity = 0.2;
    friction = 0.6;
    emap = true;
    uiName = "Rainbowizer";
    iconName = "./icon_Rainbowizer";
    doColorShift = true;
    colorShiftColor = "1.000 1.000 1.000 1.000";
    image = RainbowizerImage;
    canDrop = true;
};

datablock ShapeBaseImageData(RainbowizerImage)
{
    shapeFile = "./guitar gun.dts";
    emap = true;
    mountPoint = 0;
    offset = "0 0 0";
    eyeOffset = 0;
    rotation = eulerToMatrix( "0 0 0" );
    correctMuzzleVector = true;
    className = "WeaponImage";
    item = RainbowizerItem;
    ammo = "";
    projectile = RainbowizerProjectile;
    projectileType = Projectile;
    casing = GunShellDebris;
    shellExitDir = "1.0 0.1 1.0";
    shellExitOffset = "0 0 0";
    shellExitVariance = 10.0;	
    shellVelocity = 5.0;
    melee = false;
    armReady = true;
    doColorShift = true;
    colorShiftColor = RainbowizerItem.colorShiftColor;

	stateName[0] = "Activate";
	stateTimeoutValue[0] = 0.1;
	stateTransitionOnTimeout[0] = "Ready";
	stateSound[0] = weaponSwitchSound;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1] = true;

	stateName[2] = "Fire";
	stateTransitionOnTimeout[2] = "Smoke";
	stateTimeoutValue[2] = 0.01;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateEjectShell[2] = true;
	stateEmitter[2] = gunFlashEmitter;
	stateEmitterTime[2] = 0.2;
	stateEmitterNode[2] = "muzzleNode";
	stateWaitForTimeout[2] = true;

	stateName[3] = "Smoke";
	stateEmitter[3] = gunSmokeEmitter;
	stateEmitterTime[3] = 0.15;
	stateEmitterNode[3] = "muzzleNode";
	stateTimeoutValue[3] = 0.12;
	stateTransitionOnTimeout[3] = "Ready";
};

function RainbowizerImage::onFire(%this,%obj,%slot)
{
	%projectile = RainbowizerProjectile;
	%spread = 0.002;
	%vector1 = VectorScale(%obj.getMuzzleVector(%slot), %projectile.muzzleVelocity);
	%vector2 = VectorScale(%obj.getVelocity(), %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);
	%p = new Projectile()
	{
		dataBlock = %projectile;
		client = %obj.client;
		initialPosition = %obj.getMuzzlePoint(%slot);
		initialVelocity = %velocity;
		sourceObject = %obj;
		sourceSlot = %slot;
	};
	serverPlay3D(RainbowizerFireSound,%obj.getPosition());
	%obj.playThread(2, plant);
	%obj.spawnExplosion(RainbowizerRecoilProjectile,"1 1 1");
	MissionCleanup.add(%p);
	return %p;
}

function RainbowizerProjectile::onCollision(%this,%projectile,%hit,%what1,%pos,%what2,%velocity)
{
	parent::onCollision(%this,%projectile,%hit,%what1,%pos,%what2,%velocity);
}

function RainbowizerImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
}